import 'package:flutter/material.dart';
import 'package:nb_utils/nb_utils.dart';

class LanguageDataModel {
  int? id;
  String? name;
  String? languageCode;
  String? fullLanguageCode;
  String? flag;

  LanguageDataModel(
      {this.id,
      this.name,
      this.languageCode,
      this.flag,
      this.fullLanguageCode});

  static List<String> languages() {
    List<String> list = [];

    localeLanguageList.forEach((element) {
      list.add(element.languageCode.validate());
    });

    return list;
  }

  static List<Locale> languageLocales() {
    List<Locale> list = [];

    localeLanguageList.forEach((element) {
      list.add(Locale(element.languageCode.validate(),
          element.fullLanguageCode.validate()));
    });

    return list;
  }
}
